﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace devtm.Aop.Event
{
    

    public enum Way
    {
        In,
        Out,
        Ref
    }


    [Serializable]
    public class Parameter
    {


        public Parameter()
        {

        }


        public Parameter(string name, Type type, Object value)
            : this(name, type, value, Way.In) { }

        public Parameter(string name, Type type, Object value, Way direction)
        {            
            this.Name = name;
            this.Type = type;
            this.Value = value;
            this.Direction = direction;
        }


        public string Name { get; set; }

        public Type Type { get; set; }

        public Object Value { get; set; }

        public Way Direction { get; set; }

    }


}
