﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using devtm.Aop.Event;
using devtm.Aop.InternalProcess.Lock;

namespace devtm.Aop.InternalProcess.Cache
{
    
    public class CacheItem : LockItem
    {



        public CacheItem(uint key) : base(key)
        {
            Time = new CacheTimer();
        }

        

        private object _value = new NotSettedValue();
        public object Value
        {
            get
            {
                return _value;
            }
            set
            {
                _value = value;
            }
        }


        public CacheTimer Time { get; set; }       

    }

}
