namespace devtm.Emit
{
    using System;
    

    [Serializable]
    public class GotoStatement : Statement
    {
        private string label;

        public GotoStatement()
        {
        }

        public GotoStatement(string label)
        {
            this.Label = label;
        }

        public string Label
        {
            get
            {
                return this.label;
            }
            set
            {
                if (string.IsNullOrEmpty(value))
                {
                    throw new ArgumentNullException("value");
                }
                this.label = value;
            }
        }

        public override object Visit(Object parent, object builder)
        {
            throw new NotImplementedException();
        }
    }
}
