using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace System.ServiceModel.Dynamic.Test.ServiceModel.Cache
{
    
    public static class Helper
    {

        public static bool TryParse<T>(this string value
            , bool ignoreCase
            , out T result) where T : struct
        {

            result = default(T);

            try
            {
                result = (T)Enum.Parse(typeof(T), value, ignoreCase);
                return true;
            }
            catch
            {
                
            }

            return false;

        }

    }
}
