using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections;
using devtm.Aop;
using devtm.Aop.Extensions;

namespace devtm.Aop.InternalProcess
{
	static class IEnumerableExtensions
	{
		public static void ForEach<T>(this IEnumerable<T> collection, Action<T> action)
		{
            RequireHelper.NotNull(action, "action");
			foreach (var c in collection) action(c);
		}
	}
}