namespace devtm.Aop.Emit
{
    using System;
    using System.CodeDom;
    

    [Serializable]
    public class EmitDirectionExpression : EmitExpression
    {
        private FieldDirection direction;
        private EmitExpression expression;


        public EmitDirectionExpression()
        {
        }

        public EmitDirectionExpression(FieldDirection direction, EmitExpression expression)
        {
            this.expression = expression;
            this.direction = direction;
        }

        public FieldDirection Direction
        {
            get
            {
                return this.direction;
            }
            set
            {
                this.direction = value;
            }
        }

        public EmitExpression Expression
        {
            get
            {
                return this.expression;
            }
            set
            {
                this.expression = value;
            }
        }



        public override System.Collections.Generic.IEnumerable<Mono.Cecil.Cil.Instruction> Compile()
        {
            throw new NotImplementedException();
        }
    }
}
