﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Wcf.Contract;

namespace System.ServiceModel.Dynamic.Test
{

    class ClassContractTest : Client<IMyServiceGenericResolved>, IMyServiceGenericResolved
    {


        public ClassContractTest(string connectionStringName)
            : base(connectionStringName)
        {

        }


        public string MyOperation2(MyMessage message)
        {

            IMyServiceGenericResolved service = base.CreateInvoker();

            string retour;
            try
            {
                retour = service.MyOperation2(message);
            }
            //catch (Exception)
            //{
            //    throw;
            //}
            finally
            {
                base.FinalizeInvoker(service as ICommunicationObject);
            }

            return retour;

        }

        public string MyOperation1(MyMessage message)
        {

            IMyServiceGenericResolved service = base.CreateInvoker();

            string retour;
            try
            {
                retour = service.MyOperation1(message);
            }
            //catch (Exception)
            //{
            //    throw;
            //}
            finally
            {
                base.FinalizeInvoker(service as ICommunicationObject);
            }

            return retour;

        }
    }
}
