﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Wcf.Contract;

namespace Wcf.Implementation
{


    public class Service : IMyService
    {

        static Service()
        {

            // Initialize the default cache. the items are not added if a key allready exists in configuration section
            //CacheManager.Add<WCF.Contract.IMyService>("MyOperation", true, 200);

        }


        //[Behaviors.Logs.LogOperation]                               // Cette attribut prends en charge les logs
        //[Behaviors.PerfCounter.PerformanceCounter(Name ="call")]    // fournit un indicateur de performance permettant de compter le nombre d'appel simultané avant le cache
        //[Behaviors.Cache.Cache]                                     // La methode doit être mise en cache 
        // (Le parametrage se fait dans le fichier de configuration dans la section "cacheServiceOperation")
        //[Behaviors.PerfCounter.PerformanceCounter(Name ="real")]    // fournit un indicateur de performance permettant de compter le nombre d'appel simultané non caché
        public string MyOperation1(MyMessage message)
        {
            return message.Name;
        }





        public string MyOperation2(int message)
        {
            return message.ToString();
        }


        public MyMessage MyOperation3(int id, string message)
        {
            return new MyMessage() { Id = id, Name = message };
        }




        public bool MyOperation4(int id, ref string message)
        {
            message = "ok";
            return true;
        }


        public bool MyOperation5(ref int id)
        {
            bool r = id > 1;
            id = 100;
            return r;
        }


        public bool MyOperation6(out int id)
        {
            id = 55;
            return true;
        }


    }
}
