﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Wcf.Contract;
using System.ServiceModel;
using System.Diagnostics;

namespace Wcf.Implementation
{

    [ServiceBehavior(ConcurrencyMode = ConcurrencyMode.Multiple)]
    public class ServiceAsync : IMyServiceAsync
    {

        static ServiceAsync()
        {

            // Initialize the default cache. the items are not added if a key allready exists in configuration section
            //CacheManager.Add<WCF.Contract.IMyService>("MyOperation", true, 200);

        }


        void IMyServiceAsync.MyOperation1(MyMessage message)
        {
            message.Id = message.Id + 1;

            try
            {
                var c = Callback;
                c.MyCallbackOperation1(message);
            }
            catch (Exception ex)
            {

                StackTrace s = new StackTrace(ex);

                throw;
            }
            
        }


        IMyCallbackService Callback
        {
            get
            {
                return OperationContext.Current.GetCallbackChannel<IMyCallbackService>();
            }
        }


    }
}
